# AnnotationRequestDTO


## Fields

| Field                                                                                                                                                                                                                                                                                                                                                                                                            | Type                                                                                                                                                                                                                                                                                                                                                                                                             | Required                                                                                                                                                                                                                                                                                                                                                                                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                      |
| ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `priority`                                                                                                                                                                                                                                                                                                                                                                                                       | *int*                                                                                                                                                                                                                                                                                                                                                                                                            | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The priority of an annotation request<br/>determines the order of processing within<br/>the project.<br/><br/>Annotation requests with higher priority<br/>will be processed earlier than annotation<br/>requests with lower priority.<br/><br/>By default, the priority is 0 for all<br/>annotation requests in the project.                                                                                    |
| `clips`                                                                                                                                                                                                                                                                                                                                                                                                          | List[[models.ClipDTO](../models/clipdto.md)]                                                                                                                                                                                                                                                                                                                                                                     | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The clips to be annotated<br/>in the request                                                                                                                                                                                                                                                                                                                                                                     |
| `request_reference_id`                                                                                                                                                                                                                                                                                                                                                                                           | *str*                                                                                                                                                                                                                                                                                                                                                                                                            | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | A reference to data in<br/>the user system                                                                                                                                                                                                                                                                                                                                                                       |
| `project_id`                                                                                                                                                                                                                                                                                                                                                                                                     | *str*                                                                                                                                                                                                                                                                                                                                                                                                            | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The ID of the UAI project that is processing<br/>the annotation request                                                                                                                                                                                                                                                                                                                                          |
| `updated_at`                                                                                                                                                                                                                                                                                                                                                                                                     | [date](https://docs.python.org/3/library/datetime.html#date-objects)                                                                                                                                                                                                                                                                                                                                             | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | When the annotation request was last updated                                                                                                                                                                                                                                                                                                                                                                     |
| `created_at`                                                                                                                                                                                                                                                                                                                                                                                                     | [date](https://docs.python.org/3/library/datetime.html#date-objects)                                                                                                                                                                                                                                                                                                                                             | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | When the annotation request was created                                                                                                                                                                                                                                                                                                                                                                          |
| `export_strategy`                                                                                                                                                                                                                                                                                                                                                                                                | [models.PublicAPIExportStrategy](../models/publicapiexportstrategy.md)                                                                                                                                                                                                                                                                                                                                           | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The export strategy to use<br/><br/>UPLOAD_WORKFLOW:<br/>UAI uploads exported data<br/>via a workflow integration<br/><br/>DOWNLOAD_GCS:<br/>Download exported data via<br/>a download link                                                                                                                                                                                                                      |
| `data_intake_strategy`                                                                                                                                                                                                                                                                                                                                                                                           | [models.PublicAPIDataIntakeStrategy](../models/publicapidataintakestrategy.md)                                                                                                                                                                                                                                                                                                                                   | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The data intake strategy to use<br/><br/>UPLOAD_GCS:<br/>Upload data via a signed<br/>Google Cloud Storage URL<br/><br/>DOWNLOAD_WORKFLOW:<br/>UAI downloads data via a<br/>workflow integration                                                                                                                                                                                                                 |
| `phase`                                                                                                                                                                                                                                                                                                                                                                                                          | [models.AnnotationRequestPhase](../models/annotationrequestphase.md)                                                                                                                                                                                                                                                                                                                                             | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The processing phase of an<br/>annotation request<br/><br/>INTAKE: when data is copied<br/>to the UAI systems<br/><br/>PREPROCESSING: when data is being<br/>prepared for annotation<br/><br/>ANNOTATION: when data is being annotated<br/><br/>REVIEW: when annotated data is under<br/>review<br/><br/>DELIVERY: when data is being<br/>delivered<br/><br/>COMPLETE: when the annotation request<br/>is complete<br/><br/>ERROR: when an error occurred during<br/>processing and execution failed |
| `display_name`                                                                                                                                                                                                                                                                                                                                                                                                   | *str*                                                                                                                                                                                                                                                                                                                                                                                                            | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The display name shown in UAI tooling                                                                                                                                                                                                                                                                                                                                                                            |
| `annotation_request_id`                                                                                                                                                                                                                                                                                                                                                                                          | *str*                                                                                                                                                                                                                                                                                                                                                                                                            | :heavy_check_mark:                                                                                                                                                                                                                                                                                                                                                                                               | The ID of the annotation request<br/><br/>The ID can be used in the GET endpoint<br/>to lookup the annotation request                                                                                                                                                                                                                                                                                            |
| `review_details`                                                                                                                                                                                                                                                                                                                                                                                                 | [Optional[models.ReviewDetails]](../models/reviewdetails.md)                                                                                                                                                                                                                                                                                                                                                     | :heavy_minus_sign:                                                                                                                                                                                                                                                                                                                                                                                               | N/A                                                                                                                                                                                                                                                                                                                                                                                                              |
| `error_details`                                                                                                                                                                                                                                                                                                                                                                                                  | [Optional[models.ErrorDetails]](../models/errordetails.md)                                                                                                                                                                                                                                                                                                                                                       | :heavy_minus_sign:                                                                                                                                                                                                                                                                                                                                                                                               | N/A                                                                                                                                                                                                                                                                                                                                                                                                              |
| `callback_url`                                                                                                                                                                                                                                                                                                                                                                                                   | *Optional[str]*                                                                                                                                                                                                                                                                                                                                                                                                  | :heavy_minus_sign:                                                                                                                                                                                                                                                                                                                                                                                               | The callback URL to send<br/>annotation request updates to.                                                                                                                                                                                                                                                                                                                                                      |